const http = require('http');
const https = require('https');
const username = 'test';
const password = 'test';
const auth = 'Basic ' + Buffer.from(username + ':' + password).toString('base64');

http.request({
  host: 'localhost', // IP address of proxy server
  port: 8080, // port of proxy server
  method: 'CONNECT',
  path: 'www.google.com:443', // some destination, add 443 port for https!
  headers: {
    'Proxy-Authorization': auth
  },
}).on('connect', (res, socket) => {
  if (res.statusCode === 200) { // connected to proxy server
    const agent = new https.Agent({ socket });
    https.get({
      host: 'www.google.com:443',
      path: '/',
      agent,      // cannot use a default agent
    }, (res) => {
      let chunks = []
      res.on('data', chunk => chunks.push(chunk))
      res.on('end', () => {
        console.log('DONE', Buffer.concat(chunks).toString('utf8'))
      })
    })
  }
}).on('error', (err) => {
  console.error('error', err)
}).end();